--Ready up for Cata
--Author: Justin

--Configuration Variables
local partyMembers = 0
local unit
local achID
local isReady = false
local currentUnit
local unitName
local currentPlayer
local currentGroup
local tableOfPlayers = {}
local constructorTable = {}
local checkTheOverall = {}
local maxAch = 28

--frame
Meta = CreateFrame("Frame", "MetaFrame", UIParent)

--moving
Meta:SetScript("OnMouseDown", Meta.StartMoving)
--stop moving
Meta:SetScript("OnMouseUp", Meta.StopMovingOrSizing)

--Importent Event
Meta:RegisterEvent("INSPECT_ACHIEVEMENT_READY")

--Global Tables
currentAch = {}
theList = {}

--Check vs X
yesNo = {}
--Functions

--Making the Table
function Meta:makeTable()
	Meta:Show()
	unitName = "Everyone"
	currentUnit = "Everyone"
	Meta:personalTab() --Makes a tab that is either complete or not complete if all people are done 1, or if even 1 is not complete
	Meta:initCheck(0)
end

function Meta:initCheck(a)
	local loop = a
	if(loop<maxAch) then
		checkTheOverall[loop] = 0
		Meta:initCheck(loop+1)
	end
end

--Checking the Completionist Tab
function Meta:checkTable(a)
	unitName = "Everyone"
	currentUnit = "Everyone"
	local current = a
	if(current < currentAch[1]) then
		if(IsInGroup()) then
			if(checkTheOverall[current] >= partyMembers) then
				Meta:metaInTab(true,current)
			else
				Meta:metaInTab(false,current)
			end
		else
			if(checkTheOverall[current] == 1) then
				Meta:metaInTab(true,current)
			else
				Meta:metaInTab(false,current)
			end
		end
	Meta:checkTable(current+1)
	end
end

--Making a tab for each player
function Meta:personalTab()
	if not tableOfPlayers[unitName] then
		local tableOfAchieves = {} --100 = The graphical X/Check. 200=Name in the Tab. 300=Current Achievement name
		local trueFalses = {}
		tableOfAchieves[100] = trueFalses
		constructorTable[unitName] = tableOfAchieves
		local scan = CreateFrame( "Frame", currentUnit, InterfaceOptionsFramePanelContainer)
		tableOfPlayers[unitName] = scan
		tableOfPlayers[unitName]:Hide()
		tableOfPlayers[unitName].parent = meta.panel.name;
		tableOfPlayers[unitName].name = unitName
		InterfaceOptions_AddCategory(tableOfPlayers[unitName])
	end
	Meta:nameInTab()
end

--Putting the name into the personalTab frame
function Meta:nameInTab()
	if not constructorTable[unitName][200] then
		local title = tableOfPlayers[unitName]:CreateFontString(currentUnit, "ARTWORK", "GameFontNormalLarge")
		constructorTable[unitName][200] = title
		constructorTable[unitName][200]:SetPoint("TOP", 0, -5)
	end
	constructorTable[unitName][200]:SetText(unitName)
	Meta:achieveInTab()
end

--Putting the title of the achievement in the personal Tab
function Meta:achieveInTab()
	if not constructorTable[unitName][300] then
		local achTitle = tableOfPlayers[unitName]:CreateFontString(currentUnit.."1","ARTWORK","GameFontNormalLarge")
		constructorTable[unitName][300]=achTitle
		constructorTable[unitName][300]:SetPoint("TOP",tableOfPlayers[unitName],"TOP",0,-23)
		constructorTable[unitName][300]:SetText(currentAch[2])
	else
		constructorTable[unitName][300]:SetText(currentAch[2])
	end
end
--Putting the Achievements into the personalTab/overallTab frame
function Meta:metaInTab(b,c)
	if(constructorTable[unitName][c] == nil) then 
		local achieveText = tableOfPlayers[unitName]:CreateFontString("SPGaugeConfigPopupButtonTitle", "ARTWORK", "GameFontHighlight")
		constructorTable[unitName][c] = achieveText
	end
	local dump1, idd = GetAchievementInfo(currentAch[3][c])
	constructorTable[unitName][c]:SetText(idd)
	if(c>=(currentAch[1]/2)) then
		constructorTable[unitName][c]:SetPoint("RIGHT", tableOfPlayers[unitName], "TOPRIGHT", -35, (-30*(c-(currentAch[1]/2)))-60)
	else
		constructorTable[unitName][c]:SetPoint("RIGHT", tableOfPlayers[unitName], "TOPLEFT", 220, (-30*c)-60)
	end
	Meta:yesNo(b,c)
end

--Putting the Yes/No check or cross
function Meta:yesNo(b,c)
	if(constructorTable[unitName][100][c] == nil) then
		local boolean = tableOfPlayers[unitName]:CreateTexture(nil, "ARTWORK")
		constructorTable[unitName][100][c] = boolean
		constructorTable[unitName][100][c]:SetHeight(28)
		constructorTable[unitName][100][c]:SetWidth(28)
	end
	if(c>=(currentAch[1]/2)) then
		constructorTable[unitName][100][c]:SetPoint("RIGHT", tableOfPlayers[unitName], "TOPRIGHT", -5, (-30*(c-(currentAch[1]/2)))-60)
	else
		constructorTable[unitName][100][c]:SetPoint("RIGHT", tableOfPlayers[unitName], "TOPLEFT", 250, (-30*c)-60)
	end
	if b then
		constructorTable[unitName][100][c]:SetTexture("Interface\\AddOns\\MetaAchieve\\Textures\\check")
	else
		constructorTable[unitName][100][c]:SetTexture("Interface\\AddOns\\MetaAchieve\\Textures\\Cross")
	end
end

--Reseting the charts
function Meta:clearTables()
	Meta:clearAll(maxAch)
end

--Resets the Tab for a smooth transition
function Meta:clearAll(a)
	local current = a
	if(current >= 0) then
		if constructorTable[unitName] then
			if constructorTable[unitName][current] then
				constructorTable[unitName][current]:SetText("")
				constructorTable[unitName][100][current]:SetTexture(nil)
			end
		end
		Meta:clearAll(current-1)
	end
end


--Checking Party Members
function Meta:PartyCheckAchieve(a,b)
	currentPlayer = a
	currentGroup = b
	if(currentPlayer > 0) then
		Meta:SetFocus(currentGroup..currentPlayer)
	end
end

--Sets up the Comparison Unit for sweeping the selected meta achievement
function Meta:SetFocus(a)
	currentUnit = a
	unitName = GetUnitName(a)
	if(unitName == GetUnitName("player")) then
		currentPlayer = currentPlayer -1
		if(currentPlayer>0) then
			Meta:SetFocus(currentGroup..currentPlayer)
		end
		return;
	end
	Meta:clearTables()
	Meta:personalTab()
	if(UnitInRange(currentUnit)) then
		SetAchievementComparisonUnit(currentUnit)
	else
		print(unitName..": Was out of Range")
		constructorTable[currentUnit][200]:SetText(unitName.." :OUT OF RANGE")
		currentPlayer = currentPlayer -1
		if(currentPlayer>0) then
			Meta:SetFocus(currentGroup..currentPlayer)
		end
	end
end

--Reports each achievement as a true/false for completion
function Meta:SweepAch(a)
	local current = a
	if(current < currentAch[1]) then
		local bool = GetAchievementComparisonInfo(currentAch[3][current])
		Meta:metaInTab(bool,current)
	Meta:SweepAch(current +1)
	end
end

--Called from Menu Options, Only used to initialize a self scan
function Meta:SweepSelfDummy()
	currentUnit = "player"
	unitName = GetUnitName("player")
	Meta:clearTables()
	Meta:personalTab()
	Meta:SweepSelf(0)
end

--Only needed to scan myself since WoW handles self differently
function Meta:SweepSelf(a)
	local current = a
	if(current < currentAch[1]) then
		local dump1, dump2, dump3, bool = GetAchievementInfo(currentAch[3][current])
		Meta:metaInTab(bool,current)
		Meta:SweepSelf(current+1)
	end
end
	
--The Scan Script
Meta:SetScript("OnEvent", 
	function(self, event, ...)
		Meta:SweepAch(0)
		ClearAchievementComparisonUnit()
		if(currentPlayer > 1) then
			currentPlayer = currentPlayer -1
			Meta:SetFocus(currentGroup..currentPlayer)
		end
end)

